import { jsxs as rt, jsx as k } from "react/jsx-runtime";
import { o as st } from "../../chunks/useMergeRefs.DYDIMIZh.js";
import { y as at, i as ot, j as ct } from "../../chunks/index.BH4abVFA.js";
import lt, { useRef as g, useState as R, useEffect as it, useLayoutEffect as v } from "react";
import { TEXT_AREA_WRAPPER_CLASSNAME as nt, r as ut, TEXT_AREA_CLASSNAME as D, TEXT_AREA_CONTROL_RIGHT_CLASSNAME as dt, TEXT_AREA_HELPER_TEXT_CLASSNAME as P } from "../../chunks/constants.D-rfPeOH.js";
import c from "clsx";
function ft({
  value: t,
  defaultValue: s,
  finalValue: e,
  onChange: r = () => {
  },
  initialControlledDelay: a = 0
}) {
  const y = g(!1), [i, f] = R(), [l, p] = R(
    s !== void 0 ? s : e
  ), A = (n) => {
    p(n), r == null || r(n);
  };
  return it(() => {
    (async () => t !== void 0 && (!y.current && a > 0 && (await new Promise(
      (n) => setTimeout(n, a)
    ), y.current = !0), f(t)))();
  }, [t, a]), t !== void 0 ? [i, r, !0] : [l, A, !1];
}
const pt = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", xt = ({
  mode: t
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), yt = ({
  focusMode: t
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), ht = ({
  noBorder: t,
  error: s
}) => c("border-2", {
  "border-border-dark": !t && !s,
  "focus:border-border-dark": !t && s,
  "border-border-error-dark": !t && s,
  "border-transparent": t
}), gt = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => {
  if (s)
    return "";
  if (t)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-medium": r === "system",
      "text-copy-medium dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light": r === "system",
      "text-copy-medium dark:text-copy-error-dark": r === "alt-system"
    });
}, mt = ({
  error: t,
  raw: s,
  mode: e,
  disabled: r
}) => {
  if (s)
    return "";
  if (r)
    return c(
      P,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return c(P, "absolute px-2 font-medium", {
      "text-copy-medium": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-medium": e === "system",
      "text-copy-medium dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return c(P, "absolute px-2 font-medium", {
      "text-copy-error-light": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light": e === "system",
      "dark:text-copy-error-dark text-copy-error-light": e === "alt-system"
    });
}, kt = ({
  className: t,
  textAreaClassName: s,
  raw: e,
  focusMode: r,
  disabled: a,
  noBorder: y,
  error: i,
  spacing: f,
  mode: l
}) => {
  const p = e ? t : c(
    "relative flex w-full flex-col justify-center",
    nt,
    t,
    ut(f)
  ), A = e ? c(s) : c(
    D,
    s,
    pt(),
    xt({ mode: l }),
    yt({ focusMode: r }),
    ht({
      noBorder: y,
      error: i
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": a
    }
  ), n = e ? void 0 : "sr-only", C = gt({
    disabled: a,
    raw: e,
    error: i,
    mode: l
  }), _ = mt({
    error: i,
    raw: e,
    mode: l,
    disabled: a
  }), u = e ? void 0 : c(dt, "absolute");
  return {
    wrapper: p,
    textArea: A,
    accessibleLabel: n,
    visibleLabel: C,
    helperText: _,
    rightElement: u
  };
}, At = ({
  scrollHeight: t,
  currentHeight: s,
  currentLabelOffset: e = 0,
  currentHelperTextOffset: r = 0
}) => {
  let i, f;
  if (t > 0 && t !== s) {
    const l = t - s, p = Math.abs(l / 24);
    i = e + -1 * Math.sign(l) * (12 * p), f = r + Math.sign(l) * (12 * p);
  }
  return {
    labelOffset: i,
    helperTextOffset: f,
    scrollHeight: t
  };
}, Tt = lt.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: a = !1,
    className: y,
    textAreaClassName: i,
    mode: f = "system",
    focusMode: l = "system",
    value: p,
    defaultValue: A,
    disabled: n = !1,
    noBorder: C = !1,
    labelId: _,
    helperText: u = "",
    helperTextOnFocus: L = !1,
    rightElement: N,
    onChange: F,
    onFocus: $,
    onBlur: j,
    spacing: G,
    ...W
  }, V) => {
    const d = g(null), z = st([V, d]), [B, b] = at(), O = g(80), M = g(-25), h = g(null), X = g(30), E = g(null), T = ot({ id: t, prefix: `${D}-` }), [U, q] = R(0), [J, w] = R(
      !!(!L && u)
    ), K = `${s} error, ${u}`, m = kt({
      className: y,
      textAreaClassName: i,
      error: r,
      raw: a,
      focusMode: l,
      disabled: n,
      noBorder: C,
      spacing: G,
      mode: f
    }), [x, Q] = ft({
      value: p,
      initialControlledDelay: 100,
      defaultValue: A,
      onChange: (o) => {
        F && F({
          target: {
            value: o
          }
        });
      }
    }), Y = (o) => {
      Q(o.target.value);
    }, Z = (o) => {
      L && u && w(!0), $ && $(o);
    }, tt = (o) => {
      L && u && !x && w(!1), j && j(o);
    };
    return v(() => {
      b && b.width && q(b.width + 18 + 10);
    }, [b]), v(() => {
      a || d && d.current && x !== void 0 && (d.current.style.height = "inherit", d.current.style.height = d.current.scrollHeight + "px");
    }, [x, a]), v(() => {
      a || setTimeout(() => {
        var o;
        (o = h == null ? void 0 : h.current) == null || o.style.setProperty(
          "--av-text-area-wrapper-transition",
          x ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [x, a]), v(() => {
      var o, S;
      if (!a && d && d.current && x !== void 0) {
        const { labelOffset: H, helperTextOffset: I, scrollHeight: et } = At({
          scrollHeight: d.current.scrollHeight,
          currentHeight: O.current,
          currentLabelOffset: M.current,
          currentHelperTextOffset: X.current
        });
        H && (M.current = H, (o = h == null ? void 0 : h.current) == null || o.style.setProperty(
          "--av-text-area-label",
          `${H}px`
        )), I && (X.current = I, (S = E == null ? void 0 : E.current) == null || S.style.setProperty(
          "--av-text-area-helper-text",
          `${I}px`
        )), O.current = et || O.current;
      }
    }, [x, a]), /* @__PURE__ */ rt("div", { className: m.wrapper, children: [
      /* @__PURE__ */ k(
        "label",
        {
          htmlFor: T,
          id: _,
          className: m.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ k(
        "textarea",
        {
          ref: z,
          id: T,
          name: s,
          disabled: n,
          placeholder: a ? void 0 : " ",
          className: m.textArea,
          rows: 1,
          ...u && { "aria-describedby": `${T}-helper` },
          ...r && { "aria-invalid": "true" },
          ...N && !a && { style: { paddingRight: U } },
          value: x,
          onChange: Y,
          onFocus: Z,
          onBlur: tt,
          ...W
        }
      ),
      !a && /* @__PURE__ */ k(
        "label",
        {
          ref: h,
          "aria-hidden": !0,
          htmlFor: T,
          className: m.visibleLabel,
          children: e
        }
      ),
      J && /* @__PURE__ */ k(
        "div",
        {
          ref: E,
          id: `${T}-helper`,
          className: m.helperText,
          children: u
        }
      ),
      N && /* @__PURE__ */ k(
        "div",
        {
          ref: B,
          className: m.rightElement,
          children: N
        }
      ),
      r && u && /* @__PURE__ */ k(ct, { politeness: "polite", clearAnnouncementDelay: 500, children: K })
    ] });
  }
);
Tt.displayName = "TextArea";
export {
  Tt as TextArea
};
